/*
 *  Color.h
 *  Assignment1
 *
 *  Created by Zach Gildersleeve on 1/14/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef COLOR_H
#define COLOR_H

class Color {
	public:
		float r, g, b;
		
		Color();
		Color(const Color &c);
		Color(float newR, float newG, float newB);
		
		~Color();
		
		Color &operator=(const Color &c);
		
	private:
		void clamp();
};

inline Color operator+(const Color c1, const Color c2){
	return Color(c1.r + c2.r, c1.g + c2.g, c1.b + c2.b);
}
inline Color operator-(const Color c1, const Color c2) {
	return Color(c1.r - c2.r, c1.g - c2.g, c1.b - c2.b);
}

inline Color operator*(const Color c, const float s) {
	return Color(c.r * s, c.g * s, c.b * s);
}

inline Color operator*(const Color c1, const Color c2) {
	return Color(c1.r * c2.r, c1.g * c2.g, c1.b * c2.b);
}

#endif