/*
 *  Image.cpp
 *  Assignment1
 *
 *  Created by Zach Gildersleeve on 1/17/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "Image.h"
#include <iostream>
#include <fstream>

using namespace std;

Image::Image(int w, int h) : width(w), height(h) {
	imageData = new Pixel*[width];
	for (int i = 0; i < width; i++)
	{
		imageData[i] = new Pixel[height];
	}
}

Image::~Image() {
	delete[] imageData[0];
	delete[] imageData;
}

void Image::set(int i, int j, const Color &result) {
		Pixel p;
		if (result.r < 0.0)
			p.r = 0;
		else if (result.r > 1.0)
			p.r = 255;
		else
			p.r = (char)(result.r * 255.0);
			
		if (result.g < 0.0)
			p.g = 0;
		else if (result.g > 1.0)
			p.g = 255;
		else
			p.g = (char)(result.g * 255.0);
			
		if (result.b < 0.0)
			p.b = 0;
		else if (result.b > 1.0)
			p.b = 255;
		else
			p.b = (char)(result.b * 255.0);
		
		imageData[j][i] = p;
}

void Image::write(const char *name) {
	ofstream myFile;
	
	myFile.open(name);
	
	if (myFile.is_open()) {
		myFile << "P6 " << width << " " << height << " 255\n";
		for (int i = height - 1; i >= 0; i--)
		{
			for (int j = 0; j < width; j++)
			{
				myFile << imageData[i][j].r << imageData[i][j].g << imageData[i][j].b;
			}
		}
		myFile.close();
	}
	else
		cout << "Unable to open file for output";
}
