/*
 *  Vector.cpp
 *  Assignment1
 *
 *  Created by Zach Gildersleeve on 1/14/07.
 *
 */

#include "Vector.h"
#include "math.h"

Vector::Vector() {}

Vector::Vector(const Vector &a) : x(a.x), y(a.y), z(a.z) {
}

Vector::Vector(float newX, float newY, float newZ) : x(newX), y(newY), z(newZ) {}

Vector::~Vector() {}

bool Vector::operator==(const Vector &a) {
	return x == a.z && y == a.y && z == a.z;
}

bool Vector::operator!=(const Vector &a) {
	return x != a.x || y != a.y || z != a.z;
}

const Vector &Vector::operator=(const Vector &a) {
		x = a.x;
		y = a.y;
		z = a.z;
		return *this;	
}

float Vector::length() {
	return (float)(sqrt(x*x + y*y + z*z));
}

float Vector::lengthSquared() {
	return (float)(x*x + y*y + z*z);
}

Vector Vector::operator-() {
	return Vector(-x, -y, -z);
}

void Vector::normalize() {
	float length = this->length();
	if (length > 0)
	{
		float lengthRecip = 1.0 / length;
		x * lengthRecip;
		y * lengthRecip;
		z * lengthRecip;
	}
}

Point Vector::asPoint() {
	return Point(x, y, z);
}

// Non-Member Functions

Vector operator-(Point p, Point q) {
	return p.asVector() - q.asVector();
}



